// Copyright (c) 2016 Conceptboard. All rights reserved.
//
// lib-utils.js
//  - utils for main.js AND backgroundPage.js (!!!)
//  - defines cb.util
//  - no dependencies

var cb = cb ? cb : {};
cb.util = {

	/**
	 * Captures the current screen, returns a loaded image as well as its width and height
	 */
	captureScreen : function(callback) {
		chrome.tabs.getCurrent(function(tabId) {
			chrome.tabs.captureVisibleTab(tabId, {format: 'png', quality: 100}, function(dataUrl) {
		        var img = new Image;
		        img.onload = function() {
		            callback(img, img.width, img.height);
		        };
		        img.src = dataUrl;
	        });
		});
	},

	/**
	 * Saves a new data url. Using time as key to prevent duplicates and a proper ordering.
	 *
	 * @param {string} dataUrl - Base64 encoded image (png) data string.
	 * @param {string} type - Either "full" or "clip".
	 */
	storeDataUrl : function(dataUrl, siteUrl, type, callback) {
		var items = {};
		var itemObj = {
		    'dataUrl'	: dataUrl,
		    'type'		: type,
		    'siteUrl'	: siteUrl
		};
		items[new Date().getTime()] = itemObj;
		chrome.storage.local.set(items, function() {
		  	callback();
		});
	}

};